(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Programmme dmontrant toutes les posibilits offertes par une manette.  
 Il peut lire 4 boutons, un POV et 4 axes : X, Y, rotation et vitesse.      
                                                                            
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 -> 'Manette.Pcx'  : Image de fond                                          
*)

{$G+ :Utilise les fonctions du 286 : SHL & SHR (multiplication ultra rapide) }

{$M 4096,0,16000}

uses Clavier,EcranTxt,EcranVga,ManetJeu,PalVideo,Pcx,Vesa2;

type
  CoulOnOff = array[0..1] of RVB;

type
  TypeIndexCoulPov = record Haut,Bas,Gauche,Droite: byte end;

const
  { Index des couleurs }
  CoulFond = 103;

  IndexCoulPov : array[1..2] of TypeIndexCoulPov =
  ( (Haut:248; Bas:249; Gauche:250; Droite:251),
    (Haut:252; Bas:253; Gauche:254; Droite:255) );

  CoulRot  = 10; CoulRotA{ctif} = 2;    { Rotation et vitesse }
  CoulModel = 0; CoulModelA = 14;       { Modle de manette }

  CoulBouton : Array[1..4] of byte = (252,253,254,255);

  { Couleur en RVB (rouge,vert,bleu) }
  TableCoulB2 : CoulOnOff = ( (R:63; V:63; B: 0) , (R: 0; V: 0; B: 0) );
  TableCoulB1 : CoulOnOff = ( (R:63; V:63; B: 0) , (R:40; V:40; B:40) );
  TableCoulPov: CoulOnOff = ( (R:63; V: 0; B: 0) , (R:30; V: 0; B: 0) );

  { Position }
  ImgCalibLarg = 128; ImgCalibHaut = 64;
  ImgCalibX = (320 - ImgCalibLarg) shr 1;
  ImgCalibY = (200 - ImgCalibHaut) shr 1;

  XaxeXY = 176; YaxeXY =  42;                    { Axe X&Y }
  XaxeR  =  37; YaxeR  = 112;
  HautAxeR=13; LargAxeR = 63;                    { Rotation }
  XaxeV  = 100; YaxeV  = 119;
  HautAxeV=63; LargAxeV = 13;                    { Vitesse }
  BoutX = 5; BoutY = 11;
  HautBout=63; LargBout = 63;                    { Boutons }
  CoulFBout = 79;                                { Couleur de fond des boutons}

  ModelX = 0; ModelY =  50;                      { Liste des modles de      }
  ModelLarg = 320;                               { manette supportes        }

  { Reste }
  OuiNon : array[0..1] of String[3] = ('non','OUI');

var
  i,coul,SauveCoulXY,
  blanc,noir,TmpO: byte;

  Txt: String;
  Ch: char;

procedure DeplaceSelectManette (Plus: ShortInt); var TmpI: Integer; begin
  TmpI := TmpO +Plus;
  if TmpI<0 then TmpI := 0;
  if NbrModeleManette-1<TmpI then TmpI := NbrModeleManette-1;

  if TmpI=TmpO then exit;

  ColoriZone (ModelX,ModelY +TmpO shl 3,ModelLarg,8, noir,blanc);
  TmpO := TmpI;
  ColoriZone (ModelX,ModelY +TmpO shl 3,ModelLarg,8, blanc,noir);
end;

procedure ChangeModeleManette (Model: byte); begin
  TmpO := Model;

  { Affiche un cran de slection }
  EffaceEcran (CoulFond);
  EcriTsp (-1,0,'Choisissez le type de votre manette', blanc);
  EcriTsp (-1,8,'-----------------------------------', blanc);

  for i := 0 to NbrModeleManette do EcriTsp (ModelX,ModelY +i shl 3, NomModeleManette[i], blanc);
  ColoriZone (ModelX,ModelY +TmpO shl 3,ModelLarg,8, blanc,noir);

  EcriTsp (0,200-1-8*4,'----------------------------------------', blanc);
  EcriTsp (0,200-1-8*3,'Dplacez-vous avec les touches flchs', blanc);
  EcriTsp (0,200-1-8*2,'Validez avec espace ou entre', blanc);
  EcriTsp (0,200-1-8*1,'Annulez avec echape', blanc);

  repeat
    ch := LitTouche;
    Case ch of
    _HAUT: DeplaceSelectManette (-1);
    _BAS : DeplaceSelectManette (+1);
    end;
  until (ch=_ECHAPE) or (ch=_ENTREE) or (ch=_ESPACE);
  if ch<>_ECHAPE then Model := TmpO;
  ch := #0;

  {--- Remet l'cran prcdent ---}
  AttendEcran;

  { Efface la liste des boutons }
  RempliZone (BoutX,BoutY,LargBout,6*8,CoulFbout);

  InitManette (Model,32,5);

  AffichePcx (0,0,'Manette');
  EcriTsp (0,200-8*2, 'Manette slctionne :', blanc);
  EcriTsp (0,200-8*1, NomModeleManette[Model], noir);
end;

procedure ActuPal (IndexCoul:byte; Etat: boolean; TableCoul: CoulOnOff); begin
  if etat then
    with TableCoul[0] do ChangePal (IndexCoul, R,V,B)
  else
    with TableCoul[1] do ChangePal (IndexCoul, R,V,B);
end;

procedure Actualise; begin with Manette do begin
  AttendEcran;

  { Pixel de la position des axes X&Y }
  PutPixel (XaxeXY +Axe[_AxeX].Pourc, YaxeXY+Axe[_AxeY].Pourc ,SauveCoulXY);

  { Rotation }
  if Axe[_AxeR].Pourc<0 then
    ColoriZone (XaxeR+Axe[_AxeR].Pourc,YaxeR,-Axe[_AxeR].Pourc,HautAxeR, CoulRot, CoulRotA)
  else
    ColoriZone (XaxeR,YaxeR,Axe[_AxeR].Pourc,HautAxeR, CoulRot, CoulRotA);

  { Vitesse }
  if Axe[_AxeV].Pourc<0 then
    ColoriZone (XaxeV,YaxeV+Axe[_AxeV].Pourc, LargAxeV,-Axe[_AxeV].Pourc, CoulRot, CoulRotA)
  else
    ColoriZone (XaxeV,YaxeV, LargAxeV,Axe[_AxeV].Pourc, CoulRot, CoulRotA);

  {###############################}
  {# Lit les nouvelles positions #}
  {###############################}
  {#}        LitManette;        {#}
  {###############################}

  { Traitement du POV }
  if NbrPov<>0 then begin
    with Pov[1] do begin
      ActuPal (IndexCoulPov[1].Haut,   Y=-1, TableCoulPov); { Haut }
      ActuPal (IndexCoulPov[1].Bas,    Y=+1, TableCoulPov); { Bas }
      ActuPal (IndexCoulPov[1].Gauche, X=-1, TableCoulPov); { Gauche }
      ActuPal (IndexCoulPov[1].Droite, X=+1, TableCoulPov); { Droite }
    end;

    if NbrPov=2 then with Pov[2] do begin
      ActuPal (IndexCoulPov[2].Haut,   Y=-1, TableCoulPov); { Haut }
      ActuPal (IndexCoulPov[2].Bas,    Y=+1, TableCoulPov); { Bas }
      ActuPal (IndexCoulPov[2].Gauche, X=-1, TableCoulPov); { Gauche }
      ActuPal (IndexCoulPov[2].Droite, X=+1, TableCoulPov); { Droite }
    end;
  end;

  { Boutons }
  for i := 1 to NbrBouton do begin
    Str (i,Txt);
    EcriVga (BoutX,BoutY+(i-1) shl 3,'B'+Txt+': ',15,CoulFBout);
    if Bouton[i] then Coul := 14 else Coul := 7;
    EcriVga (BoutY+4*8,BoutY+(i-1) shl 3,OuiNon[ord(Bouton[i])],coul,CoulFBout);
  end;

  { Pixel de la position des axes X&Y }
  SauveCoulXY := GetPixel (XaxeXY +Axe[_AxeX].Pourc, YaxeXY+Axe[_AxeY].Pourc);
  PutPixel (XaxeXY +Axe[_AxeX].Pourc, YaxeXY+Axe[_AxeY].Pourc ,14);

  { Rotation de la manette }
  if Axe[_AxeR].Pourc<0 then
    ColoriZone (XaxeR+Axe[_AxeR].Pourc,YaxeR,-Axe[_AxeR].Pourc,HautAxeR, CoulRotA, CoulRot)
  else
    ColoriZone (XaxeR,YaxeR,Axe[_AxeR].Pourc,HautAxeR, CoulRotA, CoulRot);

  { Vitesse }
  if Axe[_AxeV].Pourc<0 then
    ColoriZone (XaxeV,YaxeV+Axe[_AxeV].Pourc, LargAxeV,-Axe[_AxeV].Pourc, CoulRotA, CoulRot)
  else
    ColoriZone (XaxeV,YaxeV, LargAxeV,Axe[_AxeV].Pourc, CoulRotA, CoulRot);
end end;

procedure AffichePositions; begin
  with Manette do begin
    Str (Axe[_AxeX].pourc:3, txt); EcriVga (238,100,'X: '+txt,15,CoulFond);
    Str (Axe[_AxeY].pourc:3, txt); EcriVga (238,108,'Y: '+txt,15,CoulFond);
    Str (Axe[_AxeR].pourc:3, txt); EcriVga (238,116,'R: '+txt,15,CoulFond);
    Str (Axe[_AxeV].pourc:3, txt); EcriVga (238,124,'A: '+txt,15,CoulFond);
  end;
end;

procedure Init; begin
  if not ManettePresente then begin
    EffaceEcranTxt;
    EcriTcr ('Aucune manette de jeu n''est connecte  l''ordinateur ...',12);
    SauteLigne;
    Halt (1);
  end;

  LanceMode (320,200,8); AffichePcx (0,0,'Manette');
  blanc := CouleurBlanche;
  noir  := CouleurNoire;

  ChangeModeleManette (Manette.Modele);

  LitManette;
  with Manette do
    SauveCoulXY := GetPixel (XaxeXY +Axe[_AxeX].Pourc, YaxeXY+Axe[_AxeY].Pourc);
end;

begin
  Init;

  repeat
    Actualise;

    AffichePositions;

    if TouchPresse then begin
      Ch := UpCase(LitTouche);

      Case Ch of

      { Change le modle de la manette }
      _ESPACE: ChangeModeleManette (Manette.Modele);

      { Reinitialise la manette }
      'R': InitManette (Manette.Modele,32,5);
      end;
    end;

  until Ch=_ECHAPE;

  ModeTxt;
end.
